#include "stdafx.h"
#include "Process.h"
#include "Undeclared.h"
#include <climits>

NTSTATUS GetRunningProcesses(UCHAR** ppProcessBuffer)
{
	ASSERT(ppProcessBuffer && "Invalid output buffer");
	PAGED_CODE();
	NTSTATUS stat = STATUS_SUCCESS;
	ULONG dwInSize = 32000, dwOutSize = dwInSize;
	UCHAR* pBuffer = new UCHAR[dwInSize];
	// loop around until we get a big enough buffer, 
	// we succeed, or fail with a non-length related error
	while(pBuffer && (stat = ZwQuerySystemInformation(SystemProcessInformation, pBuffer, dwInSize, &dwOutSize)) == STATUS_INFO_LENGTH_MISMATCH)
	{
		dwInSize = dwOutSize;
		delete [] pBuffer;
		pBuffer = new UCHAR[dwInSize];
	}
	if(!NT_SUCCESS(stat))
	{
		if(pBuffer)
		{
			delete [] pBuffer;
		}
	}
	else
	{
		*ppProcessBuffer = pBuffer;
	}
	return stat;
}
